using EvaPOS_API_FRAME.DTO;
using EvaPosSrvDTO;
using EvaPosSrvResp;
using GatewaySCO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Serialization;

namespace EvaPOS_API_FRAME.Adaptadores
{
    /// <summary>
    /// Crear adaptador para cerrar la lane
    /// </summary>
    public class AdaptadorTerminateRequest : IAdaptadorDTO
    {
        public string Referencia { get; set; } = "scsns:Terminate";
        public string NombreElementoXMLDatos { get; set; } = "./TerminateRequest";

        public DTOBase ObtieneDTO(int idSesion, TipoMensaje tipoMensaje, XmlElement docXml)
        {
            XmlNode? nodo = docXml.SelectSingleNode(NombreElementoXMLDatos);
            XmlSerializer serializer = new XmlSerializer(typeof(TerminateRequestDTO));
            TerminateRequestDTO dto;
            XmlNodeReader elemento = new XmlNodeReader(nodo);

            dto = (TerminateRequestDTO)serializer.Deserialize(elemento);

            if (nodo == null)
                throw new Exception($"Elemento '{NombreElementoXMLDatos}'.");

            dto.IdSesion = idSesion;
            dto.TipoMensaje = tipoMensaje;
            //Cambio: LeeIntEnNodo por LeeStringEnNodo
            dto.DestroySession = Util.LeeBoolEnNodo(nodo, "./DestroySession");

            return dto;

        }

        public IAdaptadorDTO CreaCopia()
        {
            return (AdaptadorTerminateRequest)this.MemberwiseClone();
        }
    }
}
